#include "DTSource.h"
#include "DTSaveError.h"

DTDoubleArray Computation(DTDoubleArray input,double a);

int main(int argc,const char *argv[])
{
    DTSetArguments(argc,argv);
    
    DTMatlabDataFile inputFile("Input.mat",DTFile::ReadOnly);
    // Read in the input variables.
    DTDoubleArray input = inputFile.ReadDoubleArray("input");
    double a = inputFile.ReadNumber("a");
    
    // The computation.
    DTDoubleArray computed;
    clock_t t_before = clock();
    computed = Computation(input,a);
    clock_t t_after = clock();
    double exec_time = double(t_after-t_before)/double(CLOCKS_PER_SEC);
    
    // Write the output.
    DTMatlabDataFile outputFile("Output.mat",DTFile::NewReadWrite);
    
    // Output from computation
    outputFile.Save(computed,"Var");
    outputFile.Save("NumberList","Seq_Var");
    
    // The execution time.
    outputFile.Save(exec_time,"ExecutionTime");
    outputFile.Save("Real Number","Seq_ExecutionTime");
    
    // The errors.
    DTSaveError(outputFile,"ExecutionErrors");
    outputFile.Save("StringList","Seq_ExecutionErrors");
    
    return 0;
}

DTDoubleArray Computation(DTDoubleArray input,double a)
{
    DTMutableDoubleArray toReturn;
    
    // Insert your code here.
    toReturn = input+a;
    
    DTErrorMessage("Computation","Finished computing.");
    input.pinfo(); // Intended to be called from the debugger to inspect a variable.
    
    return toReturn;
}
